Attribute VB_Name = "ModEvents"



Private Const ID_EMOTE = &H17
Private Const ID_WHISPTO = &HA
Private Const ID_WHISPFROM = &H4
Private Const ID_TALK = &H5
Private Const ID_USER = &H1
Private Const ID_JOIN = &H2
Private Const ID_LEAVE = &H3
Private Const ID_FLAGS = &H9
Private Const ID_CHAN = &H7
Private Const ID_ERROR = &H13
Private Const ID_INFO = &H12

 Function MakeLong(x As String) As Long
 On Error Resume Next
    If Len(x) < 4 Then
        Exit Function
    End If
    CopyMemory MakeLong, ByVal x, 4
End Function

Public Sub strcpy(ByRef Source As String, ByVal nText As String)
On Error Resume Next
    Source = Source & nText
End Sub

Public Function KillNull(ByVal Text As String) As String
On Error Resume Next
    Dim i As Integer
    i = InStr(1, Text, Chr(0))
    If i = 0 Then
        KillNull = Text
        Exit Function
    End If
    KillNull = Left(Text, i - 1)
End Function

Public Sub GetValues(ByVal DataBuf As String, ByRef ping As Long, ByRef flags As Long, ByRef name As String, ByRef Txt As String)
    On Error Resume Next
    Dim a As Long, b As Long, c As Long, D As Long, e As Long, f As Long, recvbufpos As Long
    name = ""
    Txt = ""
    recvbufpos = 5
    f = MakeLong(Mid$(DataBuf, recvbufpos, 4))
    recvbufpos = recvbufpos + 4
    a = CVL(Mid$(DataBuf, recvbufpos, 4))
    recvbufpos = recvbufpos + 4
    b = MakeLong(Mid$(DataBuf, recvbufpos, 4))
    recvbufpos = recvbufpos + 4
    c = MakeLong(Mid$(DataBuf, recvbufpos, 4))
    recvbufpos = recvbufpos + 4
    D = MakeLong(Mid$(DataBuf, recvbufpos, 4))
    recvbufpos = recvbufpos + 4
    e = MakeLong(Mid$(DataBuf, recvbufpos, 4))
    recvbufpos = recvbufpos + 4
    flags = a
    ping = b
    Call strcpy(name, KillNull(Mid$(DataBuf, 29)))
    Call strcpy(Txt, KillNull(Mid$(DataBuf, Len(name) + 30)))
End Sub

Public Sub ParseBinary(strData As String)
On Error Resume Next
Dim usrFlags&, ping&, usrName$, usrText$
    GetValues strData, ping, usrFlags, usrName, usrText
        
  usrFlags = FlagsIDsplt(strData)
   Select Case Asc(Mid(strData, 5, 1))
            Case ID_WHISPFROM: Event_RecvWhisper usrName, usrFlags, usrText
            Case ID_TALK: Event_Talk usrName, usrFlags, usrText
            Case ID_EMOTE: Event_Emote usrName, usrFlags, usrText
            Case ID_JOIN: Event_Join usrName, usrFlags, usrText, ping
            Case ID_USER: Event_User usrName, usrFlags, usrText, ping
            Case ID_FLAGS: Event_Flags usrName, usrFlags, usrText
            Case ID_ERROR: Event_Error usrText
            Case ID_WHISPTO: Event_SendWhisper usrName, usrFlags, usrText
            Case ID_CHAN: Event_Channel usrText
            Case ID_INFO: Event_Info usrText
            Case ID_LEAVE: Event_Leave usrName, usrFlags
            Case Else: Event_Unknown strData
        End Select
End Sub
Private Sub Event_Unknown(strText As String)
On Error Resume Next
Form1.sckBot.SendData "1006 BROADCAST " & strText & vbCrLf
End Sub
Private Sub Event_Broadcast(strText As String)
On Error Resume Next
Form1.sckBot.SendData "1006 BROADCAST """ & strText & """" & vbCrLf
End Sub
Private Sub Event_Channel(strText As String)
On Error Resume Next
Form1.sckBot.SendData "1007 CHANNEL """ & strText & """" & vbCrLf
End Sub
Private Sub Event_Flags(strUser As String, StrFlag, strstatstring)
On Error Resume Next
Form1.sckBot.SendData "1009 USER " & strUser & " " & Format(StrFlag, "0000") & vbCrLf
End Sub
Private Sub Event_Info(strText As String)
On Error Resume Next
Form1.sckBot.SendData "1018 INFO " & """" & strText & """" & vbCrLf
de
End Sub
Private Sub Event_Error(strText As String)
On Error Resume Next
Form1.sckBot.SendData "1019 Error """ & strText & """" & vbCrLf
End Sub
Private Sub Event_User(strUser As String, StrFlag, strstatstring, ping)
On Error Resume Next
Dim Text As String
Text = Left(strstatstring, 4)
Form1.sckBot.SendData "1001 USER " & strUser & " " & Format(StrFlag, "0000") & " [" & StrReverse(Text) & "]" & " " & ping & vbCrLf
de
End Sub
Private Sub Event_Join(strUser As String, StrFlag, strstatstring, ping)
On Error Resume Next
Dim Text As String
Text = Left(strstatstring, 4)
Form1.sckBot.SendData "1002 JOIN " & strUser & " " & Format(StrFlag, "0000") & " [" & StrReverse(Text) & "]" & " " & ping & vbCrLf
de
End Sub
Private Sub Event_Leave(strUser As String, StrFlag)
On Error Resume Next
Form1.sckBot.SendData "1003 LEAVE " & strUser & vbCrLf
de
End Sub
Private Sub Event_SendWhisper(strUser, StrFlag, strText)
On Error Resume Next
Form1.sckBot.SendData "1010 WHISPER " & strUser & " " & Format(StrFlag, "0000") & " """ & strText & """" & vbCrLf

End Sub
Private Sub Event_RecvWhisper(strUser As String, StrFlag, strText As String)
On Error Resume Next
Form1.sckBot.SendData "1004 WHISPER " & strUser & " " & Format(StrFlag, "0000") & " """ & strText & """" & vbCrLf

End Sub
Private Sub Event_Talk(strUser As String, StrFlag, strText As String)
On Error Resume Next
Form1.sckBot.SendData "1005 TALK " & strUser & " " & Format(StrFlag, "0000") & " """ & strText & """" & vbCrLf

End Sub
Public Sub Event_Emote(User As String, flags As Long, Text As String)
On Error Resume Next
Form1.sckBot.SendData "1023 EMOTE " & User & " " & Format(flags, "0000") & " """ & Text & """" & vbCrLf

End Sub

